/*******************************************************************************
 * FoxCustomPlayerActor generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxCustomPlayerActor extends FoxCustomActor
    native(Weapon)
    config(CustomPlayerActor)
    hidecategories(Navigation);

var() export editinline SkeletalMeshComponent UpperBodyMesh;
var() export editinline SkeletalMeshComponent HelmetMesh;
var() export editinline SkeletalMeshComponent Gear_Tactical;
var() export editinline StaticMeshComponent Gear_R1;
var() export editinline StaticMeshComponent Gear_R2;
var() export editinline StaticMeshComponent Gear_L1;
var() export editinline StaticMeshComponent Gear_L2;
var() export editinline MeshComponent Badge;
var() export editinline StaticMeshComponent Patch;
var() export editinline ParticleSystemComponent BadgePSC_TP;
var() export editinline ParticleSystemComponent BadgePSC_Local;
var() export editinline ParticleSystemComponent HelmetPSC;
var() export editinline ParticleSystemComponent HangerPSC;
var() export editinline FoxSkeletalMesh3rdPersonWeapon MyWeapon;
var class<FoxSkeletalMesh3rdPersonWeapon> MyWeaponClass;
var Texture PatchTexture;
var float PatchTextureColorOverride;
var LinearColor PatchIconColor;
var LinearColor PatchShapeColor;
var Texture OverlayCamoTexture;
var ProfileGearInfo GearInfo;
var array<MaterialInstanceConstant> TPCamoSwapMICs;
var float IdealHelmetDistance;
var float IdealBadgeDistance;
var float IdealGearDistance;
var float IdealPatchDistance;
var() config array<config Vector> PlayerOffsetArray;
var() config array<config Rotator> PlayerRotationArray;
var() config array<config float> CameraDistanceArray;
var() config array<config Vector> CameraZoomHeightOffsetArray;
var private const name TP_IKBoneCtrl_Male_LeftHand_Name;
var private const name TP_IKBoneCtrl_Female_LeftHand_Name;
var() name IdleAnimName;
var() private name FullBodySlotName;
var() private name UpperBodySlotName;
var() private name LowerBodySlotName;
var transient AnimNodeSlot FullBodyAnimNode;
var transient AnimNodeSlot UpperBodyAnimNode;
var transient AnimNodeSlot LowerBodyAnimNode;
var transient bool bIsFemale;
var transient class<FoxPawn> DefaultPawnClass;
var transient FoxDataStore_Unlockables UnlockablesDataStore;
var() export editinline SkeletalMeshComponent EffectMeshComp;

private final simulated function InitIK()
{
    local GameSkelControlLimb gscl_active, gscl_inactive;

    // End:0x2B
    if(WorldInfo.NetMode == NM_DedicatedServer)
    {
        return;
    }
    // End:0xB4
    if(bIsFemale == true)
    {
        gscl_active = GameSkelControlLimb(SkeletalMeshComponent.FindSkelControl(TP_IKBoneCtrl_Female_LeftHand_Name));
        gscl_inactive = GameSkelControlLimb(SkeletalMeshComponent.FindSkelControl(TP_IKBoneCtrl_Male_LeftHand_Name));
    }
    // End:0x12A
    else
    {
        gscl_active = GameSkelControlLimb(SkeletalMeshComponent.FindSkelControl(TP_IKBoneCtrl_Male_LeftHand_Name));
        gscl_inactive = GameSkelControlLimb(SkeletalMeshComponent.FindSkelControl(TP_IKBoneCtrl_Female_LeftHand_Name));
    }
    // End:0x159
    if(gscl_inactive != none)
    {
        gscl_inactive.SetSkelControlActive(false);
    }
    // End:0x16B
    if(gscl_active != none)
    {
    }
    // End:0x180
    else
    {
        SetTimer(0.010, false, 'InitIK');
        return;
    }
    // End:0x25E
    if((((MyWeapon == none) || !MyWeapon.bAttached) || MyWeapon.CurrentWeaponInfo.WeaponClass == none) || !MyWeapon.CurrentWeaponInfo.WeaponClass.default.bEnableArmoryIdleIK)
    {
        gscl_active.SetSkelControlActive(false);
        return;
    }
    // End:0x334
    if(MyWeapon != none)
    {
        // End:0x30C
        if((MyWeapon.BarrelModMesh != none) && MyWeapon.BarrelModMesh.SkeletalMesh != none)
        {
            gscl_active.EffectorSpaceOtherComponent = MyWeapon.BarrelModMesh;
        }
        // End:0x334
        else
        {
            gscl_active.EffectorSpaceOtherComponent = MyWeapon;
        }
    }
    gscl_active.SetSkelControlActive(true);
    //return;    
}

// Export UFoxCustomPlayerActor::execCalculateIdealVectorFromCamera(FFrame&, void* const)
native function Vector CalculateIdealVectorFromCamera(float OffsetX, float OffsetY, float IdealWidth, float IdealHeight);

// Export UFoxCustomPlayerActor::execSetIdealCameraPosition(FFrame&, void* const)
native function SetIdealCameraPosition(float OffsetX, float OffsetY, float IdealWidth, float IdealHeight);

// Export UFoxCustomPlayerActor::execSetCameraDistance(FFrame&, void* const)
native function SetCameraDistance(float NewCameraDistance);

// Export UFoxCustomPlayerActor::execSetCustomBoundingBox(FFrame&, void* const)
native function SetCustomBoundingBox();

// Export UFoxCustomPlayerActor::execGetPreviewRotation(FFrame&, void* const)
native function Rotator GetPreviewRotation(optional Rotator OffsetRotation);

simulated function UpdateGearInfo(ProfileGearInfo NewGearInfo, optional bool bForceReattachAll)
{
    local FoxDataProvider_GearInfo GearInfoProvider;
    local Object TestObject;
    local bool bReattachEverything, bRedoPatchMat, bRedoAllCamo, bRedoUpperCamo, bRedoHelmetCamo, bRedoTacticalCamo,
	    bRedoGearCamo;

    local LightingChannelContainer NewLightingChannel;
    local int I;
    local bool bSetHighlight, bGenderChanged, bSameAvatarType;
    local MaterialInstanceConstant PatchMIC;
    local ParticleSystem LocalFXPS, TPPPawnFXPS;
    local FoxPRI OwnerPRI;

    bForceReattachAll = false;
    OwnerPRI = FoxPRI(OwnerPC.PlayerReplicationInfo);
    bSetHighlight = ((HighlightItemType >= 0) && HighlightItemType <= 13) && HighlightItemType != 4;
    // End:0x9B
    if(bWasHighlighted && !bSetHighlight)
    {
        bRedoAllCamo = true;
    }
    bWasHighlighted = bSetHighlight;
    UnlockablesDataStore = FoxDataStore_Unlockables(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxUnlockables'));
    // End:0x195
    if((GearInfo.AvatarID != -1) && NewGearInfo.AvatarID != -1)
    {
        bSameAvatarType = GearInfo.AvatarID == NewGearInfo.AvatarID;
    }
    // End:0x282
    if(NewGearInfo.AvatarID != -1)
    {
        bGenderChanged = UnlockablesDataStore.AvatarProviderArray[NewGearInfo.AvatarID].bFemale != bIsFemale;
        bIsFemale = UnlockablesDataStore.AvatarProviderArray[NewGearInfo.AvatarID].bFemale;
    }
    // End:0x2DE
    else
    {
        bGenderChanged = bIsFemale != NewGearInfo.bFemale;
        bIsFemale = NewGearInfo.bFemale;
    }
    DefaultPawnClass = class<FoxPawn>(DynamicLoadObject("FoxGameContent_CHA.FoxPawn_ContentBase", class'Class', false));
    // End:0x2EAB
    if(bForceReattachAll || GearInfo != NewGearInfo)
    {
        // End:0x40C
        if(((NewGearInfo.BodyCamoID != GearInfo.BodyCamoID) || NewGearInfo.BodyCamoID < 0) || !bSameAvatarType)
        {
            SetNewCamoTextures(Max(0, NewGearInfo.BodyCamoID));
            bRedoAllCamo = true;
        }
        // End:0x5A4
        if(((((NewGearInfo.PatchIconID != GearInfo.PatchIconID) || NewGearInfo.PatchShapeID != GearInfo.PatchShapeID) || NewGearInfo.PatchIconColorID != GearInfo.PatchIconColorID) || NewGearInfo.PatchShapeColorID != GearInfo.PatchShapeColorID) || NewGearInfo.PatchIconID <= 0)
        {
            SetNewPatchTexture(NewGearInfo.PatchIconID, NewGearInfo.PatchIconColorID, NewGearInfo.PatchShapeColorID);
            bRedoPatchMat = true;
        }
        // End:0x5D8
        if(bGenderChanged || bForceReattachAll)
        {
            bReattachEverything = true;
            bRedoAllCamo = true;
        }
        // End:0xAB7
        if((bReattachEverything || NewGearInfo.LowerBodyID != GearInfo.LowerBodyID) || NewGearInfo.AvatarID != GearInfo.AvatarID)
        {
            I = SkeletalMeshComponent.Attachments.Length - 1;
            J0x693:
            // End:0x70E [Loop If]
            if(I > -1)
            {
                SkeletalMeshComponent.DetachComponent(SkeletalMeshComponent.Attachments[I].Component);
                -- I;
                // [Loop Continue]
                goto J0x693;
            }
            // End:0xAB7
            if(((((NewGearInfo.AvatarID != -1) && NewGearInfo.AvatarID < UnlockablesDataStore.AvatarProviderArray.Length) && !NewGearInfo.bBot) || ((NewGearInfo.AvatarID != -1) && NewGearInfo.AvatarID < UnlockablesDataStore.AIAvatarProviderArray.Length) && NewGearInfo.bBot) || (NewGearInfo.LowerBodyID != 255) && NewGearInfo.LowerBodyID < UnlockablesDataStore.LowerBodyProviderArray.Length)
            {
                // End:0x95E
                if(NewGearInfo.AvatarID != -1)
                {
                    GearInfoProvider = ((NewGearInfo.bBot) ? UnlockablesDataStore.AIAvatarProviderArray[NewGearInfo.AvatarID] : UnlockablesDataStore.AvatarProviderArray[NewGearInfo.AvatarID]);
                }
                // End:0x9AE
                else
                {
                    GearInfoProvider = FoxDataProvider_GearInfo(UnlockablesDataStore.LowerBodyProviderArray[NewGearInfo.LowerBodyID]);
                }
                SkeletalMeshComponent.SetSkeletalMesh(GearInfoProvider.GetSkelMeshAsset(bIsFemale, OwnerPRI));
                // End:0xA9C
                if(NewGearInfo.AvatarID != -1)
                {
                    FoxDataProvider_Avatar(GearInfoProvider).SetAvatarSkin(SkeletalMeshComponent, true);
                    CamoInfo.OverlayColor = FoxDataProvider_Avatar(GearInfoProvider).OverlayColor;
                }
                bReattachEverything = true;
                bRedoAllCamo = true;
                J0xAB7:
            }
            // End:0xAB7
            else
            {
            }
        }
        // End:0xE18
        if(bReattachEverything || NewGearInfo.UpperBodyID != GearInfo.UpperBodyID)
        {
            I = SkeletalMeshComponent.Attachments.Length - 1;
            J0xB33:
            // End:0xBAE [Loop If]
            if(I > -1)
            {
                SkeletalMeshComponent.DetachComponent(SkeletalMeshComponent.Attachments[I].Component);
                -- I;
                // [Loop Continue]
                goto J0xB33;
            }
            // End:0xDE9
            if((NewGearInfo.UpperBodyID != 255) && NewGearInfo.UpperBodyID < UnlockablesDataStore.UpperBodyProviderArray.Length)
            {
                GearInfoProvider = FoxDataProvider_GearInfo(UnlockablesDataStore.UpperBodyProviderArray[NewGearInfo.UpperBodyID]);
                UpperBodyMesh.SetSkeletalMesh(GearInfoProvider.GetSkelMeshAsset(bIsFemale, OwnerPRI));
                // End:0xD3C
                if(NewGearInfo.AvatarID == -1)
                {
                    class'FoxPawn'.static.CopySkeletalMeshSockets(UpperBodyMesh.SkeletalMesh, SkeletalMeshComponent.SkeletalMesh);
                }
                UpperBodyMesh.SetParentAnimComponent(SkeletalMeshComponent);
                UpperBodyMesh.SetShadowParent(SkeletalMeshComponent);
                bRedoUpperCamo = true;
                bReattachEverything = true;
                UpperBodyMesh.SetHidden(NewGearInfo.AvatarID != -1);
            }
            // End:0xE18
            else
            {
                // End:0xE18
                if(UpperBodyMesh != none)
                {
                    UpperBodyMesh.SetHidden(true);
                }
            }
        }
        // End:0x11DF
        if(bReattachEverything || NewGearInfo.HelmetID != GearInfo.HelmetID)
        {
            // End:0x11BE
            if(((NewGearInfo.HelmetID != 255) && NewGearInfo.HelmetID < UnlockablesDataStore.HelmetProviderArray.Length) && NewGearInfo.AvatarID == -1)
            {
                GearInfoProvider = FoxDataProvider_GearInfo(UnlockablesDataStore.HelmetProviderArray[NewGearInfo.HelmetID]);
                HelmetMesh.SetSkeletalMesh(GearInfoProvider.GetSkelMeshAsset(bIsFemale, OwnerPRI));
                HelmetMesh.SetShadowParent(SkeletalMeshComponent);
                bRedoHelmetCamo = true;
                // End:0x1024
                if(bReattachEverything)
                {
                    SkeletalMeshComponent.AttachComponentToSocket(HelmetMesh, class'FoxPawn'.default.HelmetSocketName);
                }
                TPPPawnFXPS = GearInfoProvider.GetTPPawnFXParticleSystemAsset(OwnerPRI);
                // End:0x119A
                if(TPPPawnFXPS != none)
                {
                    HelmetPSC.SetTemplate(TPPPawnFXPS);
                    HelmetMesh.AttachComponentToSocket(HelmetPSC, GearInfoProvider.GetTPPawnFXBoneName(OwnerPRI));
                    HelmetPSC.SetActive(true);
                    HelmetPSC.SetColorParameter('Color', ((EmissiveColor == class'FoxTeamInfo'.default.EnemyTeamEmissive) ? class'FoxTeamInfo'.default.EnemyTeamColor : class'FoxTeamInfo'.default.FriendlyTeamColor));
                }
                // End:0x11BB
                else
                {
                    HelmetPSC.SetActive(false);
                }
            }
            // End:0x11DF
            else
            {
                HelmetPSC.SetActive(false);
            }
        }
        NewLightingChannel = SkeletalMeshComponent.LightingChannels;
        // End:0x13EB
        if(bReattachEverything || NewGearInfo.TacticalID != GearInfo.TacticalID)
        {
            // End:0x13EB
            if((NewGearInfo.TacticalID != 255) && NewGearInfo.TacticalID < UnlockablesDataStore.AttachmentProviderArray.Length)
            {
                GearInfoProvider = FoxDataProvider_GearInfo(UnlockablesDataStore.TacticalProviderArray[NewGearInfo.TacticalID]);
                Gear_Tactical.SetSkeletalMesh(GearInfoProvider.GetSkelMeshAsset(bIsFemale, OwnerPRI));
                Gear_Tactical.SetShadowParent(SkeletalMeshComponent);
                bRedoTacticalCamo = true;
                // End:0x13EB
                if(bReattachEverything)
                {
                    SkeletalMeshComponent.AttachComponentToSocket(Gear_Tactical, class'FoxPawn'.default.Gear_TacticalSocketName);
                }
            }
        }
        // End:0x16B3
        if(bReattachEverything || NewGearInfo.Gear_R1ID != GearInfo.Gear_R1ID)
        {
            // End:0x148E
            if(!bReattachEverything && Gear_R1 != none)
            {
                SkeletalMeshComponent.DetachComponent(Gear_R1);
                Gear_R1 = none;
            }
            // End:0x16B3
            if((NewGearInfo.Gear_R1ID != 255) && NewGearInfo.Gear_R1ID < UnlockablesDataStore.AttachmentProviderArray.Length)
            {
                GearInfoProvider = FoxDataProvider_GearInfo(UnlockablesDataStore.AttachmentProviderArray[NewGearInfo.Gear_R1ID]);
                TestObject = GearInfoProvider.GetStaticMeshAsset(bIsFemale, OwnerPRI);
                Gear_R1 = new (self) class'StaticMeshComponent';
                Gear_R1.bIgnoreMaxDrawDistance = true;
                Gear_R1.SetDepthPriorityGroup(2);
                Gear_R1.SetStaticMesh(StaticMesh(TestObject));
                SkeletalMeshComponent.AttachComponentToSocket(Gear_R1, class'FoxPawn'.default.Gear_R1SocketName);
                Gear_R1.SetShadowParent(SkeletalMeshComponent);
                Gear_R1.SetLightingChannels(NewLightingChannel);
                bRedoGearCamo = true;
            }
        }
        // End:0x197E
        if(bReattachEverything || NewGearInfo.Gear_R2ID != GearInfo.Gear_R2ID)
        {
            // End:0x1756
            if(!bReattachEverything && Gear_R2 != none)
            {
                SkeletalMeshComponent.DetachComponent(Gear_R2);
                Gear_R2 = none;
            }
            // End:0x197E
            if((NewGearInfo.Gear_R2ID != 255) && NewGearInfo.Gear_R2ID < UnlockablesDataStore.AttachmentProviderArray.Length)
            {
                GearInfoProvider = FoxDataProvider_GearInfo(UnlockablesDataStore.AttachmentProviderArray[NewGearInfo.Gear_R2ID]);
                TestObject = GearInfoProvider.GetStaticMeshAsset(bIsFemale, OwnerPRI);
                Gear_R2 = new (self) class'StaticMeshComponent';
                Gear_R2.bIgnoreMaxDrawDistance = true;
                Gear_R2.SetDepthPriorityGroup(2);
                Gear_R2.SetStaticMesh(StaticMesh(TestObject));
                SkeletalMeshComponent.AttachComponentToSocket(Gear_R2, class'FoxPawn'.default.Gear_R2SocketName);
                Gear_R2.SetShadowParent(SkeletalMeshComponent);
                Gear_R2.SetLightingChannels(NewLightingChannel);
                bRedoGearCamo = true;
                J0x197E:
            }
            // End:0x197E
            else
            {
            }
        }
        // End:0x1C46
        if(bReattachEverything || NewGearInfo.Gear_L1ID != GearInfo.Gear_L1ID)
        {
            // End:0x1A21
            if(!bReattachEverything && Gear_L1 != none)
            {
                SkeletalMeshComponent.DetachComponent(Gear_L1);
                Gear_L1 = none;
            }
            // End:0x1C46
            if((NewGearInfo.Gear_L1ID != 255) && NewGearInfo.Gear_L1ID < UnlockablesDataStore.AttachmentProviderArray.Length)
            {
                GearInfoProvider = FoxDataProvider_GearInfo(UnlockablesDataStore.AttachmentProviderArray[NewGearInfo.Gear_L1ID]);
                TestObject = GearInfoProvider.GetStaticMeshAsset(bIsFemale, OwnerPRI);
                Gear_L1 = new (self) class'StaticMeshComponent';
                Gear_L1.bIgnoreMaxDrawDistance = true;
                Gear_L1.SetDepthPriorityGroup(2);
                Gear_L1.SetStaticMesh(StaticMesh(TestObject));
                SkeletalMeshComponent.AttachComponentToSocket(Gear_L1, class'FoxPawn'.default.Gear_L1SocketName);
                Gear_L1.SetShadowParent(SkeletalMeshComponent);
                Gear_L1.SetLightingChannels(NewLightingChannel);
                bRedoGearCamo = true;
            }
        }
        // End:0x1F0E
        if(bReattachEverything || NewGearInfo.Gear_L2ID != GearInfo.Gear_L2ID)
        {
            // End:0x1CE9
            if(!bReattachEverything && Gear_L2 != none)
            {
                SkeletalMeshComponent.DetachComponent(Gear_L2);
                Gear_L2 = none;
            }
            // End:0x1F0E
            if((NewGearInfo.Gear_L2ID != 255) && NewGearInfo.Gear_L2ID < UnlockablesDataStore.AttachmentProviderArray.Length)
            {
                GearInfoProvider = FoxDataProvider_GearInfo(UnlockablesDataStore.AttachmentProviderArray[NewGearInfo.Gear_L2ID]);
                TestObject = GearInfoProvider.GetStaticMeshAsset(bIsFemale, OwnerPRI);
                Gear_L2 = new (self) class'StaticMeshComponent';
                Gear_L2.bIgnoreMaxDrawDistance = true;
                Gear_L2.SetDepthPriorityGroup(2);
                Gear_L2.SetStaticMesh(StaticMesh(TestObject));
                SkeletalMeshComponent.AttachComponentToSocket(Gear_L2, class'FoxPawn'.default.Gear_L2SocketName);
                Gear_L2.SetShadowParent(SkeletalMeshComponent);
                Gear_L2.SetLightingChannels(NewLightingChannel);
                bRedoGearCamo = true;
            }
        }
        // End:0x25CE
        if(bReattachEverything || NewGearInfo.BadgeID != GearInfo.BadgeID)
        {
            // End:0x1FAD
            if(!bReattachEverything && Badge != none)
            {
                SkeletalMeshComponent.DetachComponent(Badge);
                Badge = none;
            }
            // End:0x254E
            if((NewGearInfo.BadgeID != 255) && NewGearInfo.BadgeID < UnlockablesDataStore.BadgeProviderArray.Length)
            {
                GearInfoProvider = FoxDataProvider_GearInfo(UnlockablesDataStore.BadgeProviderArray[NewGearInfo.BadgeID]);
                TestObject = GearInfoProvider.GetStaticMeshAsset(bIsFemale, OwnerPRI);
                // End:0x20E7
                if(TestObject == none)
                {
                    TestObject = GearInfoProvider.GetSkelMeshAsset(bIsFemale, OwnerPRI);
                }
                // End:0x22A3
                if(TestObject != none)
                {
                    // End:0x2178
                    if(TestObject.Class == class'StaticMesh')
                    {
                        Badge = new (self) class'StaticMeshComponent';
                        StaticMeshComponent(Badge).SetStaticMesh(StaticMesh(TestObject));
                    }
                    // End:0x21CB
                    else
                    {
                        Badge = new (self) class'SkeletalMeshComponent';
                        SkeletalMeshComponent(Badge).SetSkeletalMesh(SkeletalMesh(TestObject));
                    }
                    Badge.bIgnoreMaxDrawDistance = true;
                    Badge.SetDepthPriorityGroup(2);
                    SkeletalMeshComponent.AttachComponentToSocket(Badge, class'FoxPawn'.default.Gear_BadgeSocketName);
                    Badge.SetShadowParent(SkeletalMeshComponent);
                    Badge.SetLightingChannels(NewLightingChannel);
                }
                TPPPawnFXPS = GearInfoProvider.GetTPPawnFXParticleSystemAsset(OwnerPRI);
                // End:0x23E5
                if(TPPPawnFXPS != none)
                {
                    BadgePSC_TP.SetTemplate(TPPPawnFXPS);
                    SkeletalMeshComponent.AttachComponent(BadgePSC_TP, GearInfoProvider.GetTPPawnFXBoneName(OwnerPRI), GearInfoProvider.GetTPPawnFXLocation(bIsFemale, OwnerPRI), GearInfoProvider.GetTPPawnFXRotation(bIsFemale, OwnerPRI));
                    BadgePSC_TP.SetActive(true);
                }
                // End:0x2425
                else
                {
                    BadgePSC_TP.KillParticlesForced();
                    BadgePSC_TP.SetActive(false);
                }
                LocalFXPS = GearInfoProvider.GetLocalFXParticleSystemAsset(OwnerPRI);
                // End:0x250B
                if(LocalFXPS != none)
                {
                    BadgePSC_Local.SetTemplate(LocalFXPS);
                    SkeletalMeshComponent(Badge).AttachComponentToSocket(BadgePSC_Local, GearInfoProvider.GetLocalFXSocketName(OwnerPRI));
                    BadgePSC_Local.SetActive(true);
                }
                // End:0x254B
                else
                {
                    BadgePSC_Local.KillParticlesForced();
                    BadgePSC_Local.SetActive(false);
                }
            }
            // End:0x25CE
            else
            {
                BadgePSC_TP.KillParticlesForced();
                BadgePSC_TP.SetActive(false);
                BadgePSC_Local.KillParticlesForced();
                BadgePSC_Local.SetActive(false);
            }
        }
        // End:0x28A5
        if(bReattachEverything || NewGearInfo.PatchShapeID != GearInfo.PatchShapeID)
        {
            // End:0x2671
            if(!bReattachEverything && Patch != none)
            {
                SkeletalMeshComponent.DetachComponent(Patch);
                Patch = none;
            }
            // End:0x28A5
            if((NewGearInfo.PatchShapeID != 255) && NewGearInfo.PatchShapeID < UnlockablesDataStore.PatchProviderArray.Length)
            {
                GearInfoProvider = FoxDataProvider_GearInfo(UnlockablesDataStore.PatchProviderArray[NewGearInfo.PatchShapeID]);
                TestObject = GearInfoProvider.GetStaticMeshAsset(bIsFemale, OwnerPRI);
                // End:0x28A5
                if(TestObject != none)
                {
                    Patch = new (self) class'StaticMeshComponent';
                    Patch.bIgnoreMaxDrawDistance = true;
                    Patch.SetDepthPriorityGroup(2);
                    Patch.SetStaticMesh(StaticMesh(TestObject));
                    SkeletalMeshComponent.AttachComponentToSocket(Patch, class'FoxPawn'.default.Gear_PatchSocketName);
                    Patch.SetShadowParent(SkeletalMeshComponent);
                    Patch.SetLightingChannels(NewLightingChannel);
                    bRedoPatchMat = true;
                }
            }
        }
        // End:0x2B3D
        if(Patch != none)
        {
            bRedoPatchMat = (bRedoPatchMat || NewGearInfo.PatchIconColorID != GearInfo.PatchIconColorID) || NewGearInfo.PatchShapeColorID != GearInfo.PatchShapeColorID;
            // End:0x2B3D
            if(bRedoPatchMat)
            {
                I = 0;
                J0x2967:
                // End:0x2B3D [Loop If]
                if(I < Patch.GetNumElements())
                {
                    Patch.SetMaterial(I, none);
                    PatchMIC = Patch.CreateAndSetMaterialInstanceConstant(I);
                    PatchMIC.SetForceMipLevelsToBeResident(true, true, 0.0, 16);
                    PatchMIC.SetTextureParameterValue(class'FoxPawn'.default.PatchTextureParamName, PatchTexture);
                    PatchMIC.SetScalarParameterValue(class'FoxPawn'.default.PatchColorOverrideParamName, PatchTextureColorOverride);
                    PatchMIC.SetVectorParameterValue(class'FoxPawn'.default.PatchIconColorParamName, PatchIconColor);
                    PatchMIC.SetVectorParameterValue(class'FoxPawn'.default.PatchShapeColorParamName, PatchShapeColor);
                    ++ I;
                    // [Loop Continue]
                    goto J0x2967;
                }
            }
        }
        UpdateHangerParticles(NewGearInfo.HangerID, bReattachEverything);
        // End:0x2C5C
        if((bRedoAllCamo || bSetHighlight) || bRedoGearCamo)
        {
            SetMeshMaterialsAndCamo(Gear_L2, ((bSetHighlight) ? HighlightItemType != 13 : false));
            SetMeshMaterialsAndCamo(Gear_L1, ((bSetHighlight) ? HighlightItemType != 11 : false));
            SetMeshMaterialsAndCamo(Gear_R2, ((bSetHighlight) ? HighlightItemType != 12 : false));
            SetMeshMaterialsAndCamo(Gear_R1, ((bSetHighlight) ? HighlightItemType != 10 : false));
        }
        GearInfo = NewGearInfo;
        RefreshAnimations();
        // End:0x2CC9
        if(bGenderChanged || (GearInfo.AvatarID != -1) && !bSameAvatarType)
        {
            BlendToIdleAnimation();
        }
        // End:0x2D47
        if(((bRedoTacticalCamo || bRedoPatchMat) || bSetHighlight) || bRedoAllCamo)
        {
            SetMeshMaterialsAndCamo(Gear_Tactical, ((bSetHighlight) ? HighlightItemType != 9 : false), true);
            SetEmissives(Gear_Tactical);
        }
        // End:0x2DCF
        if((GearInfo.AvatarID == -1) && bRedoAllCamo || bSetHighlight)
        {
            SetMeshMaterialsAndCamo(SkeletalMeshComponent, ((bSetHighlight) ? HighlightItemType != 2 : false));
            SetEmissives(SkeletalMeshComponent);
        }
        // End:0x2E3D
        if((bRedoAllCamo || bRedoHelmetCamo) || bSetHighlight)
        {
            SetMeshMaterialsAndCamo(HelmetMesh, ((bSetHighlight) ? HighlightItemType != 0 : false));
            SetEmissives(HelmetMesh);
        }
        // End:0x2EAB
        if((bRedoAllCamo || bRedoUpperCamo) || bSetHighlight)
        {
            SetMeshMaterialsAndCamo(UpperBodyMesh, ((bSetHighlight) ? HighlightItemType != 1 : false));
            SetEmissives(UpperBodyMesh);
        }
    }
    //return;    
}

simulated function UpdateHangerParticles(int InHangerID, bool bForce)
{
    local FoxDataProvider_Hangers HangerInfoProvider;
    local ParticleSystem TPPawnFXPS;
    local FoxPRI OwnerPRI;

    // End:0x26E
    if(bForce || InHangerID != GearInfo.HangerID)
    {
        // End:0x24F
        if(((InHangerID >= 0) && InHangerID < UnlockablesDataStore.HangerProviderArray.Length) && OwnerPC != none)
        {
            OwnerPRI = FoxPRI(OwnerPC.PlayerReplicationInfo);
            HangerInfoProvider = UnlockablesDataStore.HangerProviderArray[InHangerID];
            TPPawnFXPS = HangerInfoProvider.GetTPPawnFXParticleSystemAsset(OwnerPRI);
            // End:0x22D
            if(TPPawnFXPS != none)
            {
                HangerPSC.SetTemplate(TPPawnFXPS);
                SkeletalMeshComponent.AttachComponent(HangerPSC, HangerInfoProvider.GetTPPawnFXBoneName(OwnerPRI), HangerInfoProvider.GetTPPawnFXLocation(bIsFemale, OwnerPRI), HangerInfoProvider.GetTPPawnFXRotation(bIsFemale, OwnerPRI));
                HangerPSC.SetActive(true);
            }
            // End:0x24C
            else
            {
                HangerPSC.ResetToDefaults();
            }
        }
        // End:0x26E
        else
        {
            HangerPSC.ResetToDefaults();
        }
    }
    GearInfo.HangerID = InHangerID;
    //return;    
}

// Export UFoxCustomPlayerActor::execSetMeshMaterialsAndCamo(FFrame&, void* const)
native function SetMeshMaterialsAndCamo(MeshComponent MyMeshComponent, bool bDefocus, optional bool bPatchMaterials);

// Export UFoxCustomPlayerActor::execSetNewPatchTexture(FFrame&, void* const)
native function SetNewPatchTexture(int UnlockID, int PatchIconColorID, int PatchShapeColorID);

// Export UFoxCustomPlayerActor::execSetNewCamoTextures(FFrame&, void* const)
native function SetNewCamoTextures(int CamoIndex);

simulated function SetupLoadoutPreview(FoxLoadoutInfo Loadout, optional bool IsBot, optional bool bForceUpdateLoadout)
{
    local ProfileGearInfo MyGearInfo;

    IsBot = false;
    bForceUpdateLoadout = false;
    // End:0x35
    if(WorldInfo.NetMode == NM_DedicatedServer)
    {
        return;
    }
    // End:0x4E
    if(MyWeapon != none)
    {
        RemoveWeapon();
    }
    MyWeapon = new MyWeaponClass;
    MyGearInfo = Loadout.GetCurrentGearInfo();
    MyGearInfo.bBot = IsBot;
    UpdateGearInfo(MyGearInfo, bForceUpdateLoadout);
    MyWeapon.UpdateConfigInfo(Loadout.PrimaryWeaponInfo);
    MyWeapon.SetShadowParent(SkeletalMeshComponent);
    MyWeapon.SetWeaponDepthPriorityGroup(UpperBodyMesh.DepthPriorityGroup);
    AttachComponent(MyWeapon);
    SkeletalMeshComponent.AttachComponentToSocket(MyWeapon, 'RightHand');
    RefreshAnimations();
    SetEmissives(MyWeapon);
    //return;    
}

simulated function UpdateWeaponConfig(FoxWeaponConfigInfo InWeaponConfig)
{
    MyWeapon.UpdateConfigInfo(InWeaponConfig);
    UpdateHangerParticles(InWeaponConfig.WeaponHanger, false);
    RefreshAnimations();
    SetEmissives(MyWeapon);
    //return;    
}

simulated function RefreshAnimations()
{
    local array<AnimSet> AnimsToUse, AddlAnimSets;
    local int I;

    AnimsToUse = ((bIsFemale) ? DefaultPawnClass.default.FTPAnimSets : DefaultPawnClass.default.MTPAnimSets);
    // End:0x127
    if(GearInfo.AvatarID != -1)
    {
        AddlAnimSets = UnlockablesDataStore.AvatarProviderArray[GearInfo.AvatarID].GetAdditionalTPAnimSets();
        I = 0;
        J0xE1:
        // End:0x127 [Loop If]
        if(I < AddlAnimSets.Length)
        {
            AnimsToUse.AddItem(AddlAnimSets[I]);
            ++ I;
            // [Loop Continue]
            goto J0xE1;
        }
    }
    // End:0x249
    if((MyWeapon != none) && MyWeapon.CurrentWeaponInfo.WeaponClass != none)
    {
        // End:0x1E4
        if(bIsFemale)
        {
            AddlAnimSets = MyWeapon.CurrentWeaponInfo.WeaponClass.default.WeaponAttachmentClass.default.FCustomAnimSets;
        }
        // End:0x249
        else
        {
            AddlAnimSets = MyWeapon.CurrentWeaponInfo.WeaponClass.default.WeaponAttachmentClass.default.MCustomAnimSets;
        }
    }
    I = 0;
    J0x254:
    // End:0x29A [Loop If]
    if(I < AddlAnimSets.Length)
    {
        AnimsToUse.AddItem(AddlAnimSets[I]);
        ++ I;
        // [Loop Continue]
        goto J0x254;
    }
    SkeletalMeshComponent.AnimSets.Length = 0;
    I = 0;
    J0x2C6:
    // End:0x321 [Loop If]
    if(I < AnimsToUse.Length)
    {
        SkeletalMeshComponent.AnimSets.AddItem(AnimsToUse[I]);
        ++ I;
        // [Loop Continue]
        goto J0x2C6;
    }
    SkeletalMeshComponent.UpdateAnimations();
    InitIK();
    BlendToIdleAnimation();
    //return;    
}

simulated function RemoveWeapon()
{
    // End:0x74
    if(MyWeapon != none)
    {
        MyWeapon.DetachAllMods();
        SkeletalMeshComponent.DetachComponent(MyWeapon);
        DetachComponent(MyWeapon);
        MyWeapon = none;
    }
    //return;    
}

simulated function SetWeaponVisibility(bool bShow, optional FoxWeaponConfigInfo InWeaponConfig)
{
    // End:0x14C
    if(((MyWeapon == none) && bShow) && InWeaponConfig.WeaponClass != none)
    {
        MyWeapon = new MyWeaponClass;
        MyWeapon.UpdateConfigInfo(InWeaponConfig);
        MyWeapon.SetShadowParent(SkeletalMeshComponent);
        MyWeapon.SetWeaponDepthPriorityGroup(UpperBodyMesh.DepthPriorityGroup);
        AttachComponent(MyWeapon);
        SkeletalMeshComponent.AttachComponentToSocket(MyWeapon, 'RightHand');
        InitIK();
        SetEmissives(MyWeapon);
    }
    // End:0x227
    else
    {
        // End:0x227
        if(MyWeapon != none)
        {
            // End:0x1AF
            if(bShow)
            {
                AttachComponent(MyWeapon);
                SkeletalMeshComponent.AttachComponentToSocket(MyWeapon, 'RightHand');
            }
            // End:0x1E1
            else
            {
                DetachComponent(MyWeapon);
                MyWeapon.DetachFromAny();
            }
            MyWeapon.SetVisibility(bShow);
            InitIK();
            SetEmissives(MyWeapon);
        }
    }
    //return;    
}

simulated function bool ShouldRefreshIdle(class<FoxWeapon> OldWeaponClass)
{
    // End:0x41
    if(OldWeaponClass != MyWeapon.CurrentWeaponInfo.WeaponClass)
    {
        return true;
    }
    return false;
    //return ReturnValue;    
}

simulated function SetupAnimNodeSlots()
{
    local AnimNodeSlot Node;

    // End:0x15A
    if(SkeletalMeshComponent != none)
    {
        SkeletalMeshComponent.SetAnimTreeTemplate(DefaultPawnClass.default.Mesh.AnimTreeTemplate);
        // End:0x159
        foreach SkeletalMeshComponent.AllAnimNodes(class'AnimNodeSlot', Node)
        {
            // End:0xD7
            if(Node.NodeName == FullBodySlotName)
            {
                FullBodyAnimNode = Node;
                // End:0x158
                continue;
            }
            // End:0x119
            if(Node.NodeName == UpperBodySlotName)
            {
                UpperBodyAnimNode = Node;
                // End:0x158
                continue;
            }
            // End:0x158
            if(Node.NodeName == LowerBodySlotName)
            {
                LowerBodyAnimNode = Node;
            }            
        }        
    }
    //return;    
}

simulated function bool StartFullBodyAnimation(name CustomAnimationName, optional float BlendTime, optional bool bLooping, optional bool bForceStart, optional bool bWeaponVisiblity)
{
    local float Duration;
    local name AnimNameToPlay;

    BlendTime = 0.250;
    bLooping = true;
    bForceStart = false;
    bWeaponVisiblity = true;
    // End:0x40
    if(FullBodyAnimNode == none)
    {
        BlendTime = 0.0;
        SetupAnimNodeSlots();
    }
    // End:0x1E9
    if((FullBodyAnimNode != none) && !IsTimerActive('BlendToIdleAnimation') || bForceStart)
    {
        // End:0x147
        if((MyWeapon != none) && MyWeapon.CurrentWeaponInfo.WeaponClass != none)
        {
            AnimNameToPlay = MyWeapon.CurrentWeaponInfo.WeaponClass.static.GetAdjustedAnimName(CustomAnimationName);
            MyWeapon.SetVisibility(bWeaponVisiblity);
        }
        // End:0x15A
        else
        {
            AnimNameToPlay = CustomAnimationName;
        }
        Duration = FullBodyAnimNode.PlayCustomAnim(AnimNameToPlay, 1.0, BlendTime, 0.0, bLooping, bForceStart);
        ForceUpdateComponents();
        // End:0x1E7
        if(!bLooping)
        {
            SetTimer(Duration, false, 'BlendToIdleAnimation');
        }
        return true;
    }
    return false;
    //return ReturnValue;    
}

private final simulated function BlendToIdleAnimation()
{
    ClearTimer('BlendToIdleAnimation');
    // End:0x43
    if(MyWeapon != none)
    {
        MyWeapon.SetVisibility(true);
    }
    StartIdleAnimation();
    //return;    
}

simulated function StartMeshEffects(FoxDataProvider_Emote EmoteToPlay, optional Engine.Scene.ESceneDepthPriorityGroup DPG, optional bool bCinematic1, optional bool bCinematic2)
{
    local AnimNodeSequence SeqNode;
    local LightingChannelContainer LightingChannels;

    DPG = 2;
    bCinematic1 = false;
    bCinematic2 = true;
    FinishMeshEffects();
    // End:0x79
    if(((EmoteToPlay == none) || EmoteToPlay.EffectMesh == "") || EmoteToPlay.EffectMeshAnimSet == "")
    {
        return;
    }
    // End:0x8A
    if(EffectMeshComp == none)
    {
        return;
    }
    EmoteToPlay.ApplyMeshEffects(EffectMeshComp);
    EffectMeshComp.SetTranslation(vect(0.0, 0.0, 0.0));
    AttachComponent(EffectMeshComp);
    SeqNode = AnimNodeSequence(EffectMeshComp.Animations);
    // End:0x37E
    if((SeqNode != none) && !SeqNode.bPlaying)
    {
        EffectMeshComp.SetDepthPriorityGroup(DPG);
        // End:0x1CC
        if(bIsFemale)
        {
            SeqNode.SetAnim(EmoteToPlay.EffectMeshFemaleAnimName);
        }
        // End:0x209
        else
        {
            SeqNode.SetAnim(EmoteToPlay.EffectMeshMaleAnimName);
        }
        EffectMeshComp.SetShadowParent(SkeletalMeshComponent);
        LightingChannels = EffectMeshComp.LightingChannels;
        LightingChannels.Dynamic = false;
        LightingChannels.Cinematic_1 = bCinematic1;
        LightingChannels.Cinematic_2 = bCinematic2;
        EffectMeshComp.SetLightingChannels(LightingChannels);
        SeqNode.PlayAnim(SeqNode.bLooping, SeqNode.Rate, 0.0);
        SetTimer(SeqNode.GetAnimPlaybackLength(), false, 'FinishMeshEffects');
    }
    //return;    
}

private final simulated function FinishMeshEffects()
{
    local AnimNodeSequence SeqNode;

    ClearTimer('FinishMeshEffects');
    // End:0xC7
    if(EffectMeshComp != none)
    {
        SeqNode = AnimNodeSequence(EffectMeshComp.Animations);
        // End:0xA6
        if((SeqNode != none) && SeqNode.bPlaying)
        {
            SeqNode.StopAnim();
        }
        EffectMeshComp.SetSkeletalMesh(none);
    }
    //return;    
}

simulated function StartIdleAnimation(optional float BlendTime)
{
    BlendTime = 0.250;
    // End:0x3F
    if(IdleAnimName != 'None')
    {
        StartFullBodyAnimation(IdleAnimName, BlendTime);
    }
    //return;    
}

// Export UFoxCustomPlayerActor::execSetDepthPriorityGroup(FFrame&, void* const)
native simulated function SetDepthPriorityGroup(Engine.Scene.ESceneDepthPriorityGroup NewDepthPriorityGroup);

simulated function RedoAllCamo()
{
    SetMeshMaterialsAndCamo(Gear_L2, false);
    SetMeshMaterialsAndCamo(Gear_L1, false);
    SetMeshMaterialsAndCamo(Gear_R2, false);
    SetMeshMaterialsAndCamo(Gear_R1, false);
    SetMeshMaterialsAndCamo(Gear_Tactical, false);
    SetEmissives(Gear_Tactical);
    SetMeshMaterialsAndCamo(SkeletalMeshComponent, false);
    SetEmissives(SkeletalMeshComponent);
    SetMeshMaterialsAndCamo(HelmetMesh, false);
    SetEmissives(HelmetMesh);
    SetMeshMaterialsAndCamo(UpperBodyMesh, false);
    SetEmissives(UpperBodyMesh);
    //return;    
}

simulated function SetOverlayColor(float R, float G, float B)
{
    CamoInfo.OverlayColor.R = R;
    CamoInfo.OverlayColor.G = G;
    CamoInfo.OverlayColor.B = B;
    RedoAllCamo();
    //return;    
}

simulated function SetBaseColor(float R, float G, float B)
{
    CamoInfo.bUseBaseColor = true;
    CamoInfo.BaseColor.R = R;
    CamoInfo.BaseColor.G = G;
    CamoInfo.BaseColor.B = B;
    RedoAllCamo();
    //return;    
}

// Export UFoxCustomPlayerActor::execForceUpdatePlayerPosition(FFrame&, void* const)
native function ForceUpdatePlayerPosition();

defaultproperties
{
    begin object name=UpperBodyMeshComponent0 class=SkeletalMeshComponent
        ForcedLodModel=1
        ReplacementPrimitive=none
        DepthPriorityGroup=ESceneDepthPriorityGroup.SDPG_Foreground
        bCastStaticShadow=false
        bAcceptsDynamicDominantLightShadows=false
        bIgnoreMaxDrawDistance=true
        LightingChannels=(Cinematic_2=true)
    object end
    // Reference: SkeletalMeshComponent'Default__FoxCustomPlayerActor.UpperBodyMeshComponent0'
    UpperBodyMesh=UpperBodyMeshComponent0
    begin object name=HelmetMeshComponent0 class=SkeletalMeshComponent
        ForcedLodModel=1
        ReplacementPrimitive=none
        DepthPriorityGroup=ESceneDepthPriorityGroup.SDPG_Foreground
        bCastStaticShadow=false
        bAcceptsDynamicDominantLightShadows=false
        bIgnoreMaxDrawDistance=true
        LightingChannels=(Cinematic_2=true)
    object end
    // Reference: SkeletalMeshComponent'Default__FoxCustomPlayerActor.HelmetMeshComponent0'
    HelmetMesh=HelmetMeshComponent0
    begin object name=TacticalMeshComponent0 class=SkeletalMeshComponent
        ForcedLodModel=1
        ReplacementPrimitive=none
        DepthPriorityGroup=ESceneDepthPriorityGroup.SDPG_Foreground
        bCastStaticShadow=false
        bAcceptsDynamicDominantLightShadows=false
        bIgnoreMaxDrawDistance=true
        LightingChannels=(Cinematic_2=true)
    object end
    // Reference: SkeletalMeshComponent'Default__FoxCustomPlayerActor.TacticalMeshComponent0'
    Gear_Tactical=TacticalMeshComponent0
    begin object name=BadgeParticleSystemComponent0 class=ParticleSystemComponent
        bAutoActivate=false
        ReplacementPrimitive=none
        DepthPriorityGroup=ESceneDepthPriorityGroup.SDPG_Foreground
        bCastStaticShadow=false
        bAcceptsDynamicDominantLightShadows=false
        bIgnoreMaxDrawDistance=true
        LightingChannels=(Cinematic_2=true)
    object end
    // Reference: ParticleSystemComponent'Default__FoxCustomPlayerActor.BadgeParticleSystemComponent0'
    BadgePSC_TP=BadgeParticleSystemComponent0
    begin object name=BadgeParticleSystemComponent1 class=ParticleSystemComponent
        bAutoActivate=false
        ReplacementPrimitive=none
        DepthPriorityGroup=ESceneDepthPriorityGroup.SDPG_Foreground
        bCastStaticShadow=false
        bAcceptsDynamicDominantLightShadows=false
        bIgnoreMaxDrawDistance=true
        LightingChannels=(Cinematic_2=true)
    object end
    // Reference: ParticleSystemComponent'Default__FoxCustomPlayerActor.BadgeParticleSystemComponent1'
    BadgePSC_Local=BadgeParticleSystemComponent1
    begin object name=HelmetParticleSystemComponent0 class=ParticleSystemComponent
        bAutoActivate=false
        ReplacementPrimitive=none
        DepthPriorityGroup=ESceneDepthPriorityGroup.SDPG_Foreground
        bCastStaticShadow=false
        bAcceptsDynamicDominantLightShadows=false
        bIgnoreMaxDrawDistance=true
        LightingChannels=(Cinematic_2=true)
    object end
    // Reference: ParticleSystemComponent'Default__FoxCustomPlayerActor.HelmetParticleSystemComponent0'
    HelmetPSC=HelmetParticleSystemComponent0
    begin object name=HangerParticleSystemComponent0 class=ParticleSystemComponent
        bAutoActivate=false
        ReplacementPrimitive=none
        DepthPriorityGroup=ESceneDepthPriorityGroup.SDPG_Foreground
        bCastStaticShadow=false
        bAcceptsDynamicDominantLightShadows=false
        bIgnoreMaxDrawDistance=true
        LightingChannels=(Cinematic_2=true)
    object end
    // Reference: ParticleSystemComponent'Default__FoxCustomPlayerActor.HangerParticleSystemComponent0'
    HangerPSC=HangerParticleSystemComponent0
    MyWeaponClass=class'FoxSkeletalMesh3rdPersonWeapon'
    PatchIconColor=(R=0.0,G=0.0,B=0.0,A=1.0)
    PatchShapeColor=(R=0.0,G=0.0,B=0.0,A=1.0)
    GearInfo=(BodyCamoID=255,UpperBodyID=255,LowerBodyID=255,HelmetID=255,BadgeID=0,Gear_R1ID=255,Gear_R2ID=255,Gear_L1ID=255,Gear_L2ID=255,TacticalID=255,ButtPackID=255,bFemale=false,bBot=false,AvatarID=-1,PatchIconID=0,PatchIconColorID=255,PatchShapeID=255,PatchShapeColorID=255,HangerID=-1)
    IdealHelmetDistance=55.0
    IdealGearDistance=70.0
    PlayerOffsetArray(0)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UnrealStreamImplementations.ReadName(IUnrealStream stream)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(1)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(2)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UnrealStreamImplementations.ReadName(IUnrealStream stream)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(3)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(4)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(5)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(6)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(7)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(8)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(9)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(10)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(11)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(12)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(13)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(14)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(15)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(16)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(17)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(18)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(19)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(20)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(21)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(22)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerOffsetArray(23)=
/* Exception thrown while deserializing PlayerOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray=PlayerRotationArray(0)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(1)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentException: Der angeforderte Wert "ActivateButtonWidget" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(2)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(3)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentException: Der angeforderte Wert "bServerOwnerOnly" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(4)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(5)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UnrealStreamImplementations.ReadName(IUnrealStream stream)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(6)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(7)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UnrealStreamImplementations.ReadName(IUnrealStream stream)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(8)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(9)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UnrealStreamImplementations.ReadName(IUnrealStream stream)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(10)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(11)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(12)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentException: Der angeforderte Wert "Deployed" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(13)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentException: Der angeforderte Wert "3D Mode_1023" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(14)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(15)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(16)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentException: Der angeforderte Wert "ApplyItemTags" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(17)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentException: Der angeforderte Wert "ClearMailNotificationDelegate" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(18)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(19)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UnrealStreamImplementations.ReadName(IUnrealStream stream)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(20)=
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentException: Der angeforderte Wert "ClearMailNotificationDelegate" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    PlayerRotationArray(21)=CameraDistanceArray=/* Array type was not detected. */,
/* Exception thrown while deserializing PlayerRotationArray
System.ArgumentOutOfRangeException: Der Index lag au?erhalb des Bereichs. Er darf nicht negativ und kleiner als die Sammlung sein.
Parametername: index
   bei System.ThrowHelper.ThrowArgumentOutOfRangeException(ExceptionArgument argument, ExceptionResource resource)
   bei UELib.UName.Deserialize(IUnrealStream stream)
   bei UELib.UObjectStream.ReadNameReference()
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    
/* Exception thrown while deserializing PlayerRotationArray
End of defaultproperties stream reached...
UELib.DeserializationException: End of defaultproperties stream reached...
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags)
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    CameraDistanceArray(0)=75.0
    CameraDistanceArray(1)=105.0
    CameraDistanceArray(2)=146.0
    CameraDistanceArray(3)=70.0
    CameraDistanceArray(4)=210.0
    CameraDistanceArray(5)=210.0
    CameraDistanceArray(6)=210.0
    CameraDistanceArray(7)=210.0
    CameraDistanceArray(8)=210.0
    CameraDistanceArray(9)=105.0
    CameraDistanceArray(10)=135.0
    CameraDistanceArray(11)=135.0
    CameraDistanceArray(12)=135.0
    CameraDistanceArray(13)=135.0
    CameraDistanceArray(14)=100.0
    CameraDistanceArray(15)=195.0
    CameraDistanceArray(16)=150.0
    CameraDistanceArray(17)=200.0
    CameraDistanceArray(18)=150.0
    CameraDistanceArray(19)=210.0
    CameraDistanceArray(20)=45.0
    CameraDistanceArray(21)=210.0
    CameraDistanceArray(22)=210.0
    CameraDistanceArray(23)=174.0
    CameraZoomHeightOffsetArray=CameraZoomHeightOffsetArray(0)=
/* Exception thrown while deserializing CameraZoomHeightOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    CameraZoomHeightOffsetArray(1)=
/* Exception thrown while deserializing CameraZoomHeightOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    CameraZoomHeightOffsetArray(2)=
/* Exception thrown while deserializing CameraZoomHeightOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    CameraZoomHeightOffsetArray(3)=
/* Exception thrown while deserializing CameraZoomHeightOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    CameraZoomHeightOffsetArray(4)=
/* Exception thrown while deserializing CameraZoomHeightOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    CameraZoomHeightOffsetArray(5)=
/* Exception thrown while deserializing CameraZoomHeightOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    CameraZoomHeightOffsetArray(6)=
/* Exception thrown while deserializing CameraZoomHeightOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    CameraZoomHeightOffsetArray(7)=
/* Exception thrown while deserializing CameraZoomHeightOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    CameraZoomHeightOffsetArray(8)=
/* Exception thrown while deserializing CameraZoomHeightOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    CameraZoomHeightOffsetArray(9)=
/* Exception thrown while deserializing CameraZoomHeightOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    CameraZoomHeightOffsetArray(10)=
/* Exception thrown while deserializing CameraZoomHeightOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    CameraZoomHeightOffsetArray(11)=
/* Exception thrown while deserializing CameraZoomHeightOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    CameraZoomHeightOffsetArray(12)=
/* Exception thrown while deserializing CameraZoomHeightOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    CameraZoomHeightOffsetArray(13)=
/* Exception thrown while deserializing CameraZoomHeightOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    CameraZoomHeightOffsetArray(14)=
/* Exception thrown while deserializing CameraZoomHeightOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    CameraZoomHeightOffsetArray(15)=
/* Exception thrown while deserializing CameraZoomHeightOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    CameraZoomHeightOffsetArray(16)=
/* Exception thrown while deserializing CameraZoomHeightOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    CameraZoomHeightOffsetArray(17)=
/* Exception thrown while deserializing CameraZoomHeightOffsetArray
System.ArgumentException: Der angeforderte Wert "3D Mode" konnte nicht gefunden werden.
   bei System.Enum.TryParseEnum(Type enumType, String value, Boolean ignoreCase, EnumResult& parseResult)
   bei System.Enum.Parse(Type enumType, String value, Boolean ignoreCase)
   bei UELib.Core.UDefaultProperty.Deserialize()
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    CameraZoomHeightOffsetArray(18)=(TP_IKBoneCtrl_Male_LeftHand_Name=LeftHand_Male_IK,TP_IKBoneCtrl_Female_LeftHand_Name=LeftHand_Female_IK,FullBodySlotName=Custom_FullBody,UpperBodySlotName=Custom_UpperBody,LowerBodySlotName=Custom_LowerBody,EffectMeshComp=SkeletalMeshComponent'Default__FoxCustomPlayerActor.EffectMeshComponent1',MinCameraDistance=90.0,MaxCameraDistance=400.0,MaxYaw=65536,MinYaw=-65536,SkeletalMeshComponent=SkeletalMeshComponent'Default__FoxCustomPlayerActor.SkeletalMeshComponent0',LightEnvironment=none,FacialAudioComp=AudioComponent'Default__FoxCustomPlayerActor.FaceAudioComponent',Components=(SkeletalMeshComponent'Default__FoxCustomPlayerActor.SkeletalMeshComponent0',AudioComponent'Default__FoxCustomPlayerActor.FaceAudioComponent',SkeletalMeshComponent'Default__FoxCustomPlayerActor.UpperBodyMeshComponent0'),CollisionComponent=SkeletalMeshComponent'Default__FoxCustomPlayerActor.SkeletalMeshComponent0')
    
/* Exception thrown while deserializing CameraZoomHeightOffsetArray
End of defaultproperties stream reached...
UELib.DeserializationException: End of defaultproperties stream reached...
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags)
   bei UELib.Core.UDefaultProperty.DeserializeDefaultPropertyValue(PropertyType type, DeserializeFlags& deserializeFlags) */
    TP_IKBoneCtrl_Male_LeftHand_Name=LeftHand_Male_IK
    TP_IKBoneCtrl_Female_LeftHand_Name=LeftHand_Female_IK
    FullBodySlotName=Custom_FullBody
    UpperBodySlotName=Custom_UpperBody
    LowerBodySlotName=Custom_LowerBody
    begin object name=EffectMeshComponent1 class=SkeletalMeshComponent
        Animations=AnimNodeSequence'Default__FoxCustomPlayerActor.EffectAnimNodeSeq1'
        ReplacementPrimitive=none
    object end
    // Reference: SkeletalMeshComponent'Default__FoxCustomPlayerActor.EffectMeshComponent1'
    EffectMeshComp=EffectMeshComponent1
    MinCameraDistance=90.0
    MaxCameraDistance=400.0
    MaxYaw=65536
    MinYaw=-65536
    begin object name=SkeletalMeshComponent0 class=SkeletalMeshComponent
        Animations=AnimNodeSequence'Default__FoxCustomPlayerActor.SkeletalMeshComponent0.AnimNodeSeq0'
        ForcedLodModel=1
        bUpdateSkelWhenNotRendered=true
        ReplacementPrimitive=none
        LightEnvironment=none
        bCastStaticShadow=false
        bAcceptsDynamicDominantLightShadows=false
        LightingChannels=(Cinematic_1=false,Cinematic_2=true)
    object end
    // Reference: SkeletalMeshComponent'Default__FoxCustomPlayerActor.SkeletalMeshComponent0'
    SkeletalMeshComponent=SkeletalMeshComponent0
    LightEnvironment=none
    FacialAudioComp=AudioComponent'Default__FoxCustomPlayerActor.FaceAudioComponent'
    begin object name=SkeletalMeshComponent0 class=SkeletalMeshComponent
        Animations=AnimNodeSequence'Default__FoxCustomPlayerActor.SkeletalMeshComponent0.AnimNodeSeq0'
        ForcedLodModel=1
        bUpdateSkelWhenNotRendered=true
        ReplacementPrimitive=none
        LightEnvironment=none
        bCastStaticShadow=false
        bAcceptsDynamicDominantLightShadows=false
        LightingChannels=(Cinematic_1=false,Cinematic_2=true)
    object end
    // Reference: SkeletalMeshComponent'Default__FoxCustomPlayerActor.SkeletalMeshComponent0'
    Components(0)=SkeletalMeshComponent0
    Components(1)=AudioComponent'Default__FoxCustomPlayerActor.FaceAudioComponent'
    begin object name=UpperBodyMeshComponent0 class=SkeletalMeshComponent
        ForcedLodModel=1
        ReplacementPrimitive=none
        DepthPriorityGroup=ESceneDepthPriorityGroup.SDPG_Foreground
        bCastStaticShadow=false
        bAcceptsDynamicDominantLightShadows=false
        bIgnoreMaxDrawDistance=true
        LightingChannels=(Cinematic_2=true)
    object end
    // Reference: SkeletalMeshComponent'Default__FoxCustomPlayerActor.UpperBodyMeshComponent0'
    Components(2)=UpperBodyMeshComponent0
    begin object name=SkeletalMeshComponent0 class=SkeletalMeshComponent
        Animations=AnimNodeSequence'Default__FoxCustomPlayerActor.SkeletalMeshComponent0.AnimNodeSeq0'
        ForcedLodModel=1
        bUpdateSkelWhenNotRendered=true
        ReplacementPrimitive=none
        LightEnvironment=none
        bCastStaticShadow=false
        bAcceptsDynamicDominantLightShadows=false
        LightingChannels=(Cinematic_1=false,Cinematic_2=true)
    object end
    // Reference: SkeletalMeshComponent'Default__FoxCustomPlayerActor.SkeletalMeshComponent0'
    CollisionComponent=SkeletalMeshComponent0
}